config/routes.rb
require 'sidekiq/web'
require 'sidekiq/cron/web'
require 'sidekiq-status/web'

Rails.application.routes.draw do # rubocop:todo Metrics/BlockLength

  devise_for :users, controllers: {
    registrations: 'users/registrations'
  }

  root 'home#index'
  get '/about', to: 'home#about', as: 'about'
  get '/terms', to: 'home#licence', as: 'terms'
  get '/stats', to: 'home#stats', as: 'stats'
  get '/profile', to: 'profile#index', as: 'profile'

  namespace 'api' do
    namespace 'v1' do
      get '/', to: 'home#index'
      get '/me', to: 'users#me'

      resources :kingdoms, only: %i[index show]
      resources :subkingdoms, only: %i[index show]
      resources :division_orders, only: %i[index show]
      resources :division_classes, only: %i[index show]
      resources :divisions, only: %i[index show]
      resources :families, only: %i[index show] do
        resources :genus, only: %i[index show]
      end
      resources :genus, only: %i[index show] do
        resources :plants, only: %i[index show]
        resources :species, only: %i[index show]
      end

      resources :plants, only: %i[index show] do
        resources :species, only: %i[index show]
        post '/report', action: :report, on: :member
        get '/search', action: :search, on: :collection
      end

      resources :species, only: %i[index show] do
        resources :record_corrections, only: %i[index], path: 'corrections'
        post '/report', action: :report, on: :member
        get '/search', action: :search, on: :collection
      end

      resources :record_corrections, path: 'corrections', only: %i[index show] do
        post '/:record_type/:record_id', to: 'record_corrections#create', on: :collection
        get :mine, to: 'record_corrections#index', on: :collection, mine: true
      end

      resources :zones, path: 'distributions', only: %i[index show] do
        resources :plants, only: %i[index show]
        resources :species, only: %i[index show]
      end
    end

    namespace 'auth' do
      post '/claim', to: 'auth#claim'
    end

    match '*all', controller: 'api', action: 'cors_preflight_check', via: [:options]
  end

  namespace 'explore' do
    get '/', to: 'species#index'
    get '/data', to: 'data#index'
    resources :species, only: %i[index show] do
      resources :record_corrections, only: %i[index], path: 'corrections'
    end
    resources :genus, only: %i[index show] do
    end
    resources :record_corrections, path: 'corrections', only: %i[index show] do

    end
  end

  namespace 'management' do
    authenticate :user, ->(user) { user.admin? } do
      mount PgHero::Engine, at: 'pghero'
      mount Sidekiq::Web => '/sidekiq'
    end

    get '/', to: 'plants#index'

    resources :users
    resources :user_queries do
      get :stats, on: :collection
    end
    resources :subkingdoms
    resources :species_proposals
    resources :species_images do
      get :chaos, on: :collection
    end
    resources :record_corrections do
      patch :accept, on: :member
      patch :reject, on: :member
    end

    resources :species do
      patch :refresh, on: :member
    end

    resources :sessions
    resources :plants
    resources :major_groups
    resources :kingdoms
    resources :genuses
    resources :foreign_sources_plants
    resources :foreign_sources
    resources :families
    resources :divisions
    resources :division_orders
    resources :division_classes
  end

end

app/controllers/api/v1/plants_controller.rb
class Api::V1::PlantsController < Api::ApiController

  include WithCachedCount

  # FILTERABLE_FIELDS = %w[
  #   author
  #   common_name
  #   complete
  #   family_common_name
  #   scientific_name
  #   vegetable
  #   year
  # ].freeze

  # ORDERABLE_FIELDS = %w[
  #   author
  #   common_name
  #   complete
  #   family_common_name
  #   scientific_name
  #   vegetable
  #   year
  #   species_count
  #   images_count
  # ].freeze

  # RANGEABLE_FIELDS = %w[
  #   year
  #   species_count
  #   images_count
  # ].freeze

  def index
    @collection = collection

    links = collection_links(@collection, name: :plants)

    render_serialized_collection(
      @collection,
      SpeciesLightSerializer,
      links: links
    )
  end

  def show
    @resource = Species.friendly.find(params[:id])

    render_serialized_resource(
      @resource.plant,
      PlantSerializer,
      meta: resource_metadata(@resource.plant)
    )
  end

  # Report an error
  def report
    @resource = Species.friendly.find(params[:id])
    rc = RecordCorrection.report!(
      record: @resource,
      user: current_user,
      change_type: params[:change_type] || 'update',
      notes: params[:notes]
    )
    render_serialized_resource(
      rc,
      RecordCorrectionSerializer,
      meta: resource_metadata(rc),
      status: :created
    )
  end

  # Search on database
  # @TODO @deprecated
  def full_search
    puts 'full_search'
    @collection ||= collection
    @collection = apply_search(collection)
    @pagy, @collection = pagy(@collection)
    links = collection_links(@collection, name: %i[plants], scope: %i[search api v1])

    render_serialized_collection(
      @collection,
      SpeciesLightSerializer,
      links: links
    )
  end

  # Search on elasticsearch
  def search
    search = params.require(:q)
    search_params = search_params(
      filter_not_fields: Api::V1::SpeciesController::FILTERABLE_NOT_FIELDS,
      filter_fields: Api::V1::SpeciesController::FILTERABLE_FIELDS,
      order_fields: Api::V1::SpeciesController::ORDERABLE_FIELDS,
      range_fields: Api::V1::SpeciesController::RANGEABLE_FIELDS
    )
    options = {
      where: { main_species_id: nil }.merge(search_params[:where]),
      includes: %i[synonyms genus plant],
      boost_by: [:gbif_score],
      fields: ['common_name^10', 'common_names^8', 'scientific_name^5', 'synonyms^3', 'author', 'genus', 'family', 'family_common_name', 'distributions'],
      order: search_params[:order]
    }.compact

    @collection = Species.pagy_search(search, options)
    @pagy, @collection = pagy_searchkick(@collection, items: (params[:limit] || 20).to_i)

    links = collection_links(@collection, name: %i[plants], scope: %i[search api v1])

    render_serialized_collection(
      @collection,
      SpeciesLightSerializer,
      links: links
    )
  end

  def collection
    return @collection if @collection

    @collection = Genus.friendly.find(params[:genus_id]).species.plants if params[:genus_id]
    @collection = Zone.friendly.find(params[:zone_id].to_s.downcase).all_species.plants if params[:zone_id]

    @collection ||= Species.plants.includes(:genus)

    @collection = apply_filters(@collection, Api::V1::SpeciesController::FILTERABLE_FIELDS)
    @collection = apply_filters_not(@collection, Api::V1::SpeciesController::FILTERABLE_NOT_FIELDS)
    @collection = apply_sort(@collection, Api::V1::SpeciesController::ORDERABLE_FIELDS, default_sort: { gbif_score: :desc })
    @collection = apply_range(@collection, Api::V1::SpeciesController::RANGEABLE_FIELDS)
    # @collection = apply_search(collection)

    @pagy, @collection = pagy(@collection)
    @collection
  end

end

app/controllers/management/division_classes_controller.rb
class Management::DivisionClassesController < Management::ManagementController
  before_action :set_division_class, only: %i[show edit update destroy]

  # GET /division_classes
  # GET /division_classes.json
  def index
    @division_classes = DivisionClass.all.page params[:page]
  end

  # GET /division_classes/1
  # GET /division_classes/1.json
  def show; end

  # GET /division_classes/new
  def new
    @division_class = DivisionClass.new
  end

  # GET /division_classes/1/edit
  def edit; end

  # POST /division_classes
  # POST /division_classes.json
  def create
    @division_class = DivisionClass.new(division_class_params)

    respond_to do |format|
      if @division_class.save
        format.html { redirect_to @division_class, notice: 'Division class was successfully created.' }
        format.json { render :show, status: :created, location: @division_class }
      else
        format.html { render :new }
        format.json { render json: @division_class.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /division_classes/1
  # PATCH/PUT /division_classes/1.json
  def update
    respond_to do |format|
      if @division_class.update(division_class_params)
        format.html { redirect_to @division_class, notice: 'Division class was successfully updated.' }
        format.json { render :show, status: :ok, location: @division_class }
      else
        format.html { render :edit }
        format.json { render json: @division_class.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /division_classes/1
  # DELETE /division_classes/1.json
  def destroy
    @division_class.destroy
    respond_to do |format|
      format.html { redirect_to division_classes_url, notice: 'Division class was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_division_class
    @division_class = DivisionClass.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def division_class_params
    params.require(:division_class).permit(:name, :slug, :division_id, :inserted_at)
  end
end

app/controllers/management/division_orders_controller.rb
class Management::DivisionOrdersController < Management::ManagementController
  before_action :set_division_order, only: %i[show edit update destroy]

  # GET /division_orders
  # GET /division_orders.json
  def index
    @division_orders = DivisionOrder.all.page params[:page]
  end

  # GET /division_orders/1
  # GET /division_orders/1.json
  def show; end

  # GET /division_orders/new
  def new
    @division_order = DivisionOrder.new
  end

  # GET /division_orders/1/edit
  def edit; end

  # POST /division_orders
  # POST /division_orders.json
  def create
    @division_order = DivisionOrder.new(division_order_params)

    respond_to do |format|
      if @division_order.save
        format.html { redirect_to @division_order, notice: 'Division order was successfully created.' }
        format.json { render :show, status: :created, location: @division_order }
      else
        format.html { render :new }
        format.json { render json: @division_order.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /division_orders/1
  # PATCH/PUT /division_orders/1.json
  def update
    respond_to do |format|
      if @division_order.update(division_order_params)
        format.html { redirect_to @division_order, notice: 'Division order was successfully updated.' }
        format.json { render :show, status: :ok, location: @division_order }
      else
        format.html { render :edit }
        format.json { render json: @division_order.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /division_orders/1
  # DELETE /division_orders/1.json
  def destroy
    @division_order.destroy
    respond_to do |format|
      format.html { redirect_to division_orders_url, notice: 'Division order was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_division_order
    @division_order = DivisionOrder.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def division_order_params
    params.require(:division_order).permit(:name, :slug, :division_class_id, :inserted_at)
  end
end

app/controllers/management/divisions_controller.rb
class Management::DivisionsController < Management::ManagementController
  before_action :set_division, only: %i[show edit update destroy]

  # GET /divisions
  # GET /divisions.json
  def index
    @divisions = Division.all.page params[:page]
  end

  # GET /divisions/1
  # GET /divisions/1.json
  def show; end

  # GET /divisions/new
  def new
    @division = Division.new
  end

  # GET /divisions/1/edit
  def edit; end

  # POST /divisions
  # POST /divisions.json
  def create
    @division = Division.new(division_params)

    respond_to do |format|
      if @division.save
        format.html { redirect_to @division, notice: 'Division was successfully created.' }
        format.json { render :show, status: :created, location: @division }
      else
        format.html { render :new }
        format.json { render json: @division.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /divisions/1
  # PATCH/PUT /divisions/1.json
  def update
    respond_to do |format|
      if @division.update(division_params)
        format.html { redirect_to @division, notice: 'Division was successfully updated.' }
        format.json { render :show, status: :ok, location: @division }
      else
        format.html { render :edit }
        format.json { render json: @division.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /divisions/1
  # DELETE /divisions/1.json
  def destroy
    @division.destroy
    respond_to do |format|
      format.html { redirect_to divisions_url, notice: 'Division was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_division
    @division = Division.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def division_params
    params.require(:division).permit(:name, :slug, :subkingdom_id, :inserted_at)
  end
end

app/controllers/management/families_controller.rb
class Management::FamiliesController < Management::ManagementController
  before_action :set_family, only: %i[show edit update destroy]

  # GET /families
  # GET /families.json
  def index
    @families = Family.all.page params[:page]
  end

  # GET /families/1
  # GET /families/1.json
  def show; end

  # GET /families/new
  def new
    @family = Family.new
  end

  # GET /families/1/edit
  def edit; end

  # POST /families
  # POST /families.json
  def create
    @family = Family.new(family_params)

    respond_to do |format|
      if @family.save
        format.html { redirect_to @family, notice: 'Family was successfully created.' }
        format.json { render :show, status: :created, location: @family }
      else
        format.html { render :new }
        format.json { render json: @family.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /families/1
  # PATCH/PUT /families/1.json
  def update
    respond_to do |format|
      if @family.update(family_params)
        format.html { redirect_to @family, notice: 'Family was successfully updated.' }
        format.json { render :show, status: :ok, location: @family }
      else
        format.html { render :edit }
        format.json { render json: @family.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /families/1
  # DELETE /families/1.json
  def destroy
    @family.destroy
    respond_to do |format|
      format.html { redirect_to families_url, notice: 'Family was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_family
    @family = Family.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def family_params
    params.require(:family).permit(:name, :slug, :common_name, :division_order_id, :major_group_id, :inserted_at)
  end
end

app/controllers/management/genuses_controller.rb
class Management::GenusesController < Management::ManagementController
  before_action :set_genuse, only: %i[show edit update destroy]

  # GET /genuses
  # GET /genuses.json
  def index
    @genuses = Genus.all
    @pagy, @genuses = pagy(@genuses)
  end

  # GET /genuses/1
  # GET /genuses/1.json
  def show; end

  # GET /genuses/new
  def new
    @genuse = Genus.new
  end

  # GET /genuses/1/edit
  def edit; end

  # POST /genuses
  # POST /genuses.json
  def create
    @genuse = Genus.new(genuse_params)

    respond_to do |format|
      if @genuse.save
        format.html { redirect_to @genuse, notice: 'Genus was successfully created.' }
        format.json { render :show, status: :created, location: @genuse }
      else
        format.html { render :new }
        format.json { render json: @genuse.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /genuses/1
  # PATCH/PUT /genuses/1.json
  def update
    respond_to do |format|
      if @genuse.update(genuse_params)
        format.html { redirect_to @genuse, notice: 'Genus was successfully updated.' }
        format.json { render :show, status: :ok, location: @genuse }
      else
        format.html { render :edit }
        format.json { render json: @genuse.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /genuses/1
  # DELETE /genuses/1.json
  def destroy
    @genuse.destroy
    respond_to do |format|
      format.html { redirect_to genuses_url, notice: 'Genus was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_genuse
    @genuse = Genus.friendly.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def genuse_params
    params.require(:genuse).permit(:name, :slug, :family_id, :inserted_at)
  end
end

app/views/management/plants/_form.html.erb
<%= form_with(model: plant, local: true) do |form| %>
  <% if plant.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(plant.errors.count, "error") %> prohibited this plant from being saved:</h2>

      <ul>
      <% plant.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :slug %>
    <%= form.text_field :slug %>
  </div>

  <div class="field">
    <%= form.label :year %>
    <%= form.number_field :year %>
  </div>

  <div class="field">
    <%= form.label :bibliography %>
    <%= form.text_field :bibliography %>
  </div>

  <div class="field">
    <%= form.label :author %>
    <%= form.text_field :author %>
  </div>

  <div class="field">
    <%= form.label :status %>
    <%= form.text_field :status %>
  </div>

  <div class="field">
    <%= form.label :common_name %>
    <%= form.text_field :common_name %>
  </div>

  <div class="field">
    <%= form.label :family_common_name %>
    <%= form.text_field :family_common_name %>
  </div>

  <div class="field">
    <%= form.label :scientific_name %>
    <%= form.text_field :scientific_name %>
  </div>

  <div class="field">
    <%= form.label :usda_name %>
    <%= form.text_field :usda_name %>
  </div>

  <div class="field">
    <%= form.label :genus_id %>
    <%= form.text_field :genus_id %>
  </div>

  <div class="field">
    <%= form.label :inserted_at %>
    <%= form.datetime_select :inserted_at %>
  </div>

  <div class="field">
    <%= form.label :main_species_id %>
    <%= form.text_field :main_species_id %>
  </div>

  <div class="field">
    <%= form.label :complete_data %>
    <%= form.check_box :complete_data %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/management/plants/_plant.html.erb
<article class="media">
  <figure class="media-left">
    <p class="image is-48x48">
      <% if plant&.main_species&.species_images&.first&.image_url %>
      <img class="async-image small" data-src="<%= plant&.main_species&.species_images&.first&.image_url %>" />
      <% end %>
    </p>
  </figure>
  <div class="media-content">
    <div class="content">

      <h3>
        <i>[<%= plant.status || 'null' %>]</i>
        Plant
        <%= link_to plant.scientific_name, [:management, plant] %>
        <sup>#<%= plant.id %></sup>
      </h3>
      <progress class="progress is-small" value="<%= plant.completion_ratio %>" max="100"><%= plant.completion_ratio %>%</progress>

    </div>

    <% if plant.species.any? %>
    <% plant.species.order(:status).each do |sp| %>
    <article class="media <%= sp.id == plant.main_species_id ? 'main-specie' : 'no-main-specie' %> species species--<%= sp.status&.parameterize %>">
      <figure class="media-left">
        <p class="image is-32x32">
          <% if sp&.species_images&.first&.image_url %>
          <img class=" async-image small" data-src="<%= sp&.species_images&.first&.image_url %>" />
          <% end %>
        </p>
      </figure>
      <div class="media-content">
        <div class="content">
          <i>[<%= sp.status %>]</i>
          <mark><%= sp.species_type || 'NO SPECIES TYPE' %></mark>
          <%= link_to sp.scientific_name, [:management, sp] %>
          <sup>#<%= sp.id %></sup>
        </div>
      </div>
    </article>
    <% end %>
    <% else %>
    <b>No species</b>
    <% end %>
  </div>
</article>

app/views/management/plants/edit.html.erb
<h1>Editing Plant</h1>

<%= render 'form', plant: @plant %>

<%= link_to 'Show', @plant %> |
<%= link_to 'Back', plants_path %>

app/views/management/plants/index.html.erb
<section class="section">
  <div class="container">

    <p id="notice" class="notification is-info"><%= notice %></p>

    <h1 class="title">Plants</h1>

    <%= form_with(method: :get, data: {remote: false}) do %>
    <%= label_tag(:q, "Search for:") %>
    <%= text_field_tag(:search) %>
    <%= submit_tag("Search") %>
    <% end %>
  </div>
</section>
<section>

  <div class="table-container">

    <%== pagy_bulma_nav(@pagy) %>

    <table class="table is-striped is-hoverable is-fullwidth">
      <thead>
        <tr>
          <th></th>
          <th><%= sortable_link(:scientific_name, :management_plants_path, params) %></th>
          <th>Main species</th>
          <th><%= sortable_link(:species_count, :management_plants_path, params) %></th>
          <th><%= sortable_link(:images_count, :management_plants_path, params) %></th>
          <th><%= sortable_link(:sources_count, :management_plants_path, params) %></th>
          <th><%= sortable_link(:completion_ratio, :management_plants_path, params) %></th>

          <th><%= sortable_link(:year, :management_plants_path, params) %></th>
          <th><%= sortable_link(:author, :management_plants_path, params) %></th>
          <th><%= sortable_link(:main_species_gbif_score, :management_plants_path, params) %></th>
          <th><%= sortable_link(:reviewed_at, :management_plants_path, params) %></th>
          <th><%= sortable_link(:genus_id, :management_plants_path, params) %></th>
          <th><%= sortable_link(:created_at, :management_plants_path, params) %></th>
          <th><%= sortable_link(:updated_at, :management_plants_path, params) %></th>

          <th><%= sortable_link(:common_name, :management_plants_path, params) %></th>
          <th><%= sortable_link(:family_common_name, :management_plants_path, params) %></th>
          <th>Sources</th>
          <th colspan=" 3">
          </th>
        </tr>
      </thead>

      <tbody>
        <% @plants.each do |plant| %>
        <% cache [:plant, :index, plant.cache_key, plant.cache_version] do %>
        <tr>
          <td><img class="async-image small" data-src="<%= plant&.main_species&.species_images&.first&.image_url %>" /></td>
          <td>
            <b><%= link_to plant.scientific_name, [:management, plant] %></b>
          </td>
          <td><%= plant&.main_species && link_to(plant&.main_species&.scientific_name, management_species_path(plant&.main_species)) %></td>
          <td><%= plant.species_count || '?' %> sp</td>
          <td><%= plant.images_count || '?' %> 🖼</td>
          <td><%= plant.sources_count || '?' %> 🔗</td>
          <td><progress class="progress is-small" value="<%= plant.completion_ratio %>" max="100"><%= plant.completion_ratio %>%</progress></td>
          <td><%= table_desc(plant, :year) %></td>
          <td><%= table_desc(plant, :author) %></td>
          <td><%= plant.main_species_gbif_score %></td>
          <td><%= table_desc(plant, :reviewed_at) %></td>
          <td><%= plant&.genus && link_to(plant&.genus&.name, management_genuse_path(plant&.genus)) %></td>
          <td><%= plant.created_at&.strftime('%d/%m/%Y') %></td>
          <td><%= plant.updated_at&.strftime('%d/%m/%Y') %></td>
          <td><%= table_desc(plant, :common_name) %></td>
          <td><%= table_desc(plant, :family_common_name) %></td>
          <td><%= plant.main_species&.foreign_sources&.pluck(:name)&.join(', ') %></td>

          <td><%= link_to 'Show', [:management, plant] %></td>
          <td><%= link_to 'Edit', edit_management_plant_path(plant) %></td>
          <td><%= link_to 'Destroy', [:management, plant], method: :delete, data: { confirm: 'Are you sure?' } %></td>
        </tr>
        <% end %>
        <% end %>
      </tbody>
    </table>
  </div>
</section>
<section>
  <div class="container">

    <%== pagy_bulma_nav(@pagy) %>
    <%== pagy_info(@pagy) %>


    <br>

    <%= link_to 'New Plant', new_management_plant_path %>
  </div>
</section>

app/views/management/plants/new.html.erb
<h1>New Plant</h1>

<%= render 'form', plant: @plant %>

<%= link_to 'Back', plants_path %>

app/views/management/plants/show.html.erb
<% cache [:plant, :show, :main, @plant.cache_key, @plant.cache_version] do %>
<section class="section">
  <div class="container">
    <nav class="breadcrumb has-arrow-separator" aria-label="breadcrumbs">
      <ul>
        <li><%= @plant&.genus && link_to("Genus #{@plant&.genus&.name}", management_genuse_path(@plant&.genus))|| 'No genus' %></li>
        <li class="is-active"><%= link_to("Plant #{@plant.scientific_name}", management_plant_path(@plant)) %></li>
        <li><%= @plant&.main_species && link_to("Main species #{@plant&.main_species&.scientific_name}", management_species_path(@plant&.main_species)) || 'No main species' %></li>
      </ul>
    </nav>
    <h1 class="title">
      <%= @plant.scientific_name %>
      <sup>#<%= @plant.id %></sup>
    </h1>

    <!-- <p>
    <strong>Slug:</strong>
    <% @plant.slug %>
  </p> -->
    <div class="columns is-desktop">
      <div class="column">
        <h3 class="title is-4">General informations</h3>

        <%= field_desc(@plant, :year) %>

        <%= field_desc(@plant, :bibliography) %>

        <%= field_desc(@plant, :author) %>

        <%= field_desc(@plant, :status) %>

        <%= field_desc(@plant, :common_name) %>

        <%= field_desc(@plant, :family_common_name) %>

        <%= field_desc(@plant, :scientific_name) %>


        <div>
          <b>Genus</b> <%= @plant&.genus && link_to(@plant&.genus&.name, management_genuses_path(@plant&.genus)) || 'No Genus' %>
        </div>
        <%= field_desc(@plant, :inserted_at) %>

        <div>
          <b>Main species</b> <%= @plant&.main_species && link_to(@plant&.main_species&.scientific_name, management_species_path(@plant&.main_species)) || 'No main species' %>
        </div>

        <%= field_desc(@plant, :complete_data) %>
      </div>
      <div class="column">
        <h3 class="title is-4">Common names</h3>
        <ul>
          <% @plant&.main_species&.common_names&.where(lang: %w(fr en))&.group_by(&:lang)&.each do |lang, names| %>
          <li><b><%= lang %></b>: <%= names.pluck(:name).join(', ') %></li>
          <% end %>
        </ul>
      </div>
    </div>


    <%= link_to 'Edit', edit_management_plant_path(@plant) %> |
    <%= link_to 'Back', management_plants_path %>


    <hr>
    <h3 class="title is-3">Species</h3>

    <% @plant.species.order(:rank).each do |sp| %>
    <% cache [:plant, :show, sp] do %>
    <%= render sp %>
    <% end %>
    <% end %>
  </div>
</section>
<% end %>